Subject: Re: bug#36649: 27.0.50; pure space and pdumper

From: Po Lu <[email-masked]>
Date: Sun, 03 Jul 2022 15:42:53 +0800

Gerd Möllmann <[email-masked]> writes:

> Interesting!
>
> Is there something I could read about your new GC?

Not exactly.  It's a very simple 3 color incremental mark-and-sweep
collector (which is not generational or moving) using hardware write
barriers to keep track of changes made by the mutator.  I tried to keep
the design of the existing garbage collector intact as much as possible.

The motive was to get rid of the noticeable freeze during garbage
collection instead of making GC itself fast.

> I'm asking because I once also had plans to rewrite Emacs' GC (to be
> incremental and generational).  But hat was >20 years ago, and it
> never took off because the algorithm I used was patented.  Which it no
> longer is, I think.

Which algorithm(s) were you considering?  I think that information might
be useful.